var dragSessionEnabled = false;
var dragObserver = {
  getSupportedFlavours : function() {
    var flavours = new FlavourSet();
    flavours.appendFlavour("application/x-moz-file", "nsIFile");
    flavours.appendFlavour("text/unicode");
    return flavours;
  },
  onDragStart : function (aEvent, aDragData, aDragAction) {
    if (!isConnected || !dragSessionEnabled)
      return;

    var targetID = aEvent.target.getAttribute('id');
    if (targetID == 'localtreechildren' || targetID == 'remotetreechildren') {
      aDragData.data = new TransferData();
      aDragData.data.addDataForFlavour("text/unicode", targetID);
      aDragAction.action = Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY;
    }

    aEvent.preventBubble();
  },
  onDragOver : function (aEvent, aFlavour, aDragSession) {
    if (!isConnected) {
      aDragSession.canDrop = false;
      return;
    }

    var targetID = aEvent.target.getAttribute('id');
    aDragSession.canDrop =
      targetID == 'remotetreechildren' || (targetID == 'localtreechildren' && !aDragSession.isDataFlavorSupported("application/x-moz-file"));

    aEvent.preventBubble();
  },
  onDrop: function (aEvent, aDragData, aDragSession) {
    if (!isConnected)
      return;

    if (aDragData.data == 'localtreechildren')
      transfer(false);
    else if (aDragData.data == 'remotetreechildren')
      transfer(true);
    else {                                                    // might be dropped from OS
      var transObj = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
      transObj.addDataFlavor("application/x-moz-file");       // only look at files

      for (var x = 0; x < aDragSession.numDropItems; x++) {   // iterate through dragged items getting any files
        try {
          aDragSession.getData(transObj, x);
          var dataObj     = new Object();
          var dropSizeObj = new Object();
          transObj.getTransferData("application/x-moz-file", dataObj, dropSizeObj);

          var droppedFile = dataObj.value.QueryInterface(Components.interfaces.nsIFile);
          var fileParent  = droppedFile.parent ? droppedFile.parent.path : "";
          transfer(false, droppedFile, fileParent, gRemotePath.value, true, false);
        } catch (ex) {
          debug(ex, 231);
          continue;
        }
      }
    }
    aEvent.preventBubble();
  }
};
