function readPreferences() {  // thank God for prefwindowV - makes my life so much easier
  try {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    var prefBranch = prefs.getBranch("fireftp.");

    welcomeMode   = prefBranch.getBoolPref("welcomemode");
    errorMode     = prefBranch.getBoolPref("errormode");
    refreshMode   = prefBranch.getBoolPref("refreshmode");
    passwordMode  = prefBranch.getBoolPref("passwordmode");
    sessionsMode  = prefBranch.getBoolPref("sessionsmode");
    hiddenMode    = prefBranch.getBoolPref("hiddenmode");
    interfaceMode = prefBranch.getIntPref ("interfacemode");
    network       = prefBranch.getIntPref ("network");
    timeoutMode   = prefBranch.getBoolPref("timeoutmode");                          // read preferences
    retry         = prefBranch.getIntPref ("retry");
    attempts      = prefBranch.getIntPref ("attempts");
    destructMode  = prefBranch.getBoolPref("destructmode");
    fileMode      = prefBranch.getIntPref ("filemode");
    loadMode      = prefBranch.getIntPref ("loadmode");
    logMode       = prefBranch.getBoolPref("logmode");
    debugMode     = prefBranch.getBoolPref("debugmode");
    bytesMode     = prefBranch.getBoolPref("bytesmode");
    noPromptMode  = prefBranch.getBoolPref("nopromptmode");
    logErrorMode  = prefBranch.getBoolPref("logerrormode");
    keepAliveMode = prefBranch.getBoolPref("keepalivemode");
    proxyType     = prefBranch.getCharPref("proxytype");
    proxyHost     = prefBranch.getCharPref("proxyhost");
    proxyPort     = prefBranch.getIntPref ("proxyport");
    loadUrl       = prefBranch.getCharPref("loadurl");
    donated       = prefBranch.getBoolPref("donated");
    
    if (prefBranch.getCharPref("folder") == "") {
      var file = Components.classes["@mozilla.org/file/directory_service;1"]
                           .createInstance(Components.interfaces.nsIProperties)
                           .get("Home", Components.interfaces.nsIFile);
      if (file.path.indexOf('/') != -1)
        prefBranch.setCharPref("folder", file.path.substring(0, file.path.indexOf('/') + 1));
      else if (file.path.indexOf('\\') != -1)
        prefBranch.setCharPref("folder", file.path.substring(0, file.path.indexOf('\\') + 1));
    }

    gLocalPath.value = prefBranch.getCharPref("folder");

    updateInterface();

    document.getElementById('cmdlog').collapsed  = !logMode;
    document.getElementById('logsplitter').state = logMode ? '' : 'collapsed';      // update log view
    document.getElementById('logbutton').checked = logMode;

    var transferTypes = new Array("Auto", "Binary", "ASCII");
    document.getElementById('statustype').label = transferTypes[fileMode];          // update file mode

    var asciiFiles = prefBranch.getCharPref("asciifiles");                          // create ascii type list
    asciiFiles = asciiFiles.split(",");
    for (var x = 0; x < asciiFiles.length; ++x)
      prefAsciiFiles.push(asciiFiles[x]);
  } catch (ex) { debug(ex,7); }
}
function savePreferences(firstTime) {
  try {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefService);
    var prefBranch = prefs.getBranch("fireftp.");

    prefBranch.setIntPref ("filemode",      fileMode);
    prefBranch.setCharPref("folder",        gLocalPath.value);
    prefBranch.setBoolPref("logmode",       logMode);
    prefBranch.setIntPref ("interfacemode", interfaceMode);
  } catch (ex) { debug(ex,8); }
}
function showPreferences() {                                                        // preferences button
  var hiddenBefore   = hiddenMode;
  var bytesBefore    = bytesMode;
  var logErrorBefore = logErrorMode;

  window.openDialog("chrome://fireftp/content/preferences.xul","preferences",
    "chrome,modal=yes,dialog=yes,resizable=yes,centerscreen");
  readPreferences();

  if (bytesBefore != bytesMode) {
    localTree.updateView();
    remoteTree.treebox.invalidate();
  }

  if (logErrorBefore != logErrorMode) {
    if (logErrorMode)
      showOnlyErrors();
    else
      showAll();
  }

  if (hiddenBefore == hiddenMode)
    return;
  if (!hiddenMode) {
    var fileSpec = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
    fileSpec.initWithPath(gLocalPath.value);
    var hiddenFound = false;
    while (true) {
      if (fileSpec.isHidden() && fileSpec.path != localDirTree.data[0].path()) {
        hiddenFound = true;
        break;
      }
      if (!(parent in fileSpec) || fileSpec.path == fileSpec.parent.path)
        break;
      fileSpec = fileSpec.parent;
    }
    if (hiddenFound)
      gLocalPath.value = localDirTree.data[0].path();
  }
  localDirTree.data = new Array;
  localDirTree.treebox.rowCountChanged(0, -localDirTree.rowCount);
  localDirTree.rowCount = 0;
  localDirTree.changeDir(gLocalPath.value);
}
