function loadPrograms() {
  try {
    var profD = Components.classes["@mozilla.org/file/directory_service;1"]
                          .createInstance(Components.interfaces.nsIProperties)
                          .get("ProfD", Components.interfaces.nsIFile);
    var file = Components.classes['@mozilla.org/file/local;1']
                         .createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(profD.path + slash + "fireFTPprograms.dat");
    if (file.exists()) {                                                   // read the programs file
      var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                              .createInstance(Components.interfaces.nsIFileInputStream);
      var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
                              .createInstance(Components.interfaces.nsIScriptableInputStream);
      fstream.init(file, 1, 0, false);
      sstream.init(fstream); 

      var programData = "";
      var str = sstream.read(-1);
      while (str.length > 0) {
        programData += str;
        str = sstream.read(-1);
      }

      programs = eval(programData);

      sstream.close();
      fstream.close();
    } else {
      programs = new Array( { extension: "*.*", programs: new Array() } );
      savePrograms();
    }
  } catch (ex) {
    debug(ex, 99);
  }
}
function savePrograms() {
  // write program list out to disk
  try {
    var profD = Components.classes["@mozilla.org/file/directory_service;1"]
                         .createInstance(Components.interfaces.nsIProperties)
                         .get("ProfD", Components.interfaces.nsIFile);
    var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(profD.path + slash + "fireFTPprograms.dat");
    var foutstream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                               .createInstance(Components.interfaces.nsIFileOutputStream);
    foutstream.init(file, 0x04 | 0x08 | 0x20, 0644, 0);
    foutstream.write(programs.toSource(), programs.toSource().length);
    foutstream.close();
  } catch (ex) {
    debug(ex, 101);
  }
}
function chooseProgram() {
  var result = new Object();
  result.value = false;
  var extension = localTree.getExtension(localTree.data[localTree.selection.currentIndex].leafName);
  var tempPrograms = { value: new Array(), extension: extension };
  for (var x = 0; x < programs.length; ++x)
    tempPrograms.value.push(programs[x]);

  dialogOpen = true;
  window.openDialog("chrome://fireftp/content/programs.xul","programs",
    "width=640,height=510,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", tempPrograms, result);
  dialogOpen = false;

  if (result.value) {
    programs = tempPrograms.value;
    savePrograms();
  }
}
function launchProgram(extensionIndex, programIndex, fileIndex) {
  try {
    var program = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
    program.initWithPath(programs[extensionIndex].programs[programIndex].executable);

    var process = Components.classes['@mozilla.org/process/util;1'].getService(Components.interfaces.nsIProcess);
    process.init(program);
    var arguments = [];

    if (!programs[extensionIndex].programs[programIndex].arguments)
      arguments.push(localTree.data[fileIndex].path);
    else {
      var argumentString = programs[extensionIndex].programs[programIndex].arguments;
      while (argumentString.indexOf("%file%") != -1)
        argumentString = argumentString.substring(0, argumentString.indexOf("%file%")) 
                       + localTree.data[fileIndex].path
                       + argumentString.substring(argumentString.indexOf("%file%") + 6, argumentString.length);
      arguments.push(argumentString);
    }

    process.run(false, arguments, arguments.length, {});
  } catch (ex) {
    debug(ex, 100);
  }
}
